function laba5_p2(N,epsi,M)
   %avtosvertka 
    R = obratnoe(N, M)

    n = 0:N-1;
    k = 0:N-1;
    
    Q = zeros(N,N);
    Q(1,1) = 1;
    for j=2:N 
        Q(N+2-j, j)=1;
    end
    
    T = mod(epsi.^(n'*k),M);
    To = Q*T;
    
    %s= floor(randn(1,N)*3)
    s = [1 2 -1 3];
    
    a = mod((T*s')', M) %spectral'naja har-ka
    a = mod(a.*a,M); %avtosvertka
    S = mod(a*To*R,M) %vremennaja har-ka
    sv=ifft(fft(s).*fft(s))
    sv=cconv(s,s,N)

    
end